import 'package:redux/redux.dart';
import 'package:thesis_shop/redux/actions/actions.dart';
import 'package:thesis_shop/redux/middlewares/fetch_products_middleware.dart';
import 'package:thesis_shop/redux/state.dart';
import 'package:thesis_shop/service/product_service.dart';

import 'reducers/app_state_reducer.dart';

Store<AppState> createStore({required ProductService productService}) {
  final store = Store(
    appReducer,
    initialState: AppState.initialState(),
    middleware: [FetchProductsMiddleware(productService).fetchTodosMiddleware],
  );
  store.dispatch(FetchProductsAction());
  return store;
}
