import 'package:flutter/material.dart';
import 'package:flutter_redux/flutter_redux.dart';
import 'package:thesis_shop/models/product.dart';
import 'package:thesis_shop/redux/actions/actions.dart';
import 'package:thesis_shop/redux/state.dart';
import 'package:thesis_shop/widgets/number_picker.dart';

class ProductItem extends StatelessWidget {
  final Product product;
  const ProductItem({Key? key, required this.product}) : super(key: key);

  @override
  Widget build(BuildContext context) {
    return StoreBuilder<AppState>(
      builder: (context, store) => ListTile(
        title: Text('${product.title} (${product.priceAsString}€/Stück)'),
        trailing: NumberPicker(
          value: store.state.productQuantities[product.title] ?? 0,
          onUp: () => store.dispatch(IncrementProductAction(product: product)),
          onDown: () =>
              store.dispatch(DecrementProductAction(product: product)),
        ),
      ),
    );
  }
}
